YGS_low_comp_ver = 0.44

YssGuildShop = Rock:NewAddon("YssGuildShop", "LibRockDB-1.0", "LibRockEvent-1.0", "LibRockConsole-1.0", "LibRockHook-1.0", "LibRockModuleCore-1.0", "LibRockConfig-1.0", "LibRockTimer-1.0", "LibRockComm-1.0", "LibFuBarPlugin-3.0")
YGS_Personel_dew = Rock("Dewdrop-2.0")
YssGuildShop:SetDatabase("YGS_DB", "YGS_PC_DB")

function YssGuildShop:IsRecord()
    return YssGuildShop.db.char.YGS_settings[1]
end

function YssGuildShop:ToggleIsRecord()
    YssGuildShop.db.char.YGS_settings[1] = not YssGuildShop.db.char.YGS_settings[1]
    if YssGuildShop.db.char.YGS_settings[1] == false then
	YssGuildShop.db.char.YGSBANK = nil
	YssGuildShop.db.char.YGSBAG =  nil
    end
    self:UpdateFuBarPlugin()
end

function YssGuildShop:IsShared()
    return YssGuildShop.db.char.YGS_settings[2]
end

function YssGuildShop:ToggleIsShared()
    YssGuildShop.db.char.YGS_settings[2] = not YssGuildShop.db.char.YGS_settings[2]
    self:UpdateFuBarPlugin()
end

YssGuildShop:SetConfigTable({ 
	type='group',
	name = "YssGuildShop",
	desc = "config/options",
	icon = [[Interface\AddOns\YssGuildShop\icon]],
	args = {
		open_p = {
			type = 'execute',
			name = "Permissions",
			desc = "Opens permission GUI",
			func = function()
				YGS_GUI_Permission:Show()
			end
		},
		dump = {
			type = 'execute',
			name = "Dump",
			desc = "Dumps YssGuildShop.db.account.YGSDB into console -- debug",
			func = function()
				YssGuildShop:YGS_Data_Dump()
			end
		},
		nuke = {
			type = 'execute',
			name = "Nuke",
			desc = "Deletes all inventory data (yours and all shared data) -- debug",
			func = function()
				YssGuildShop:Nuke()
			end
		},
		share = {
			type = 'boolean',
			name = "Share",
			desc = "Sets default for sharing new items",
			get = "IsShared",
			set = "ToggleIsShared",
		},
		record = {
			type = 'boolean',
			name = "Record",
			desc = "Turn Recording on or off",
			get = "IsRecord",
			set = "ToggleIsRecord",
		}
	}
})

YssGuildShop:SetFuBarOption("iconPath", [[Interface\AddOns\YssGuildShop\icon]])

function YssGuildShop:OnFuBarClick()
	if YssGuildShop.db.char.YGSBAG and YssGuildShop.db.char.YGSBANK then
		if YGS_GUI_Personal:IsShown() then
			YGS_GUI_Personal:Hide()
		else
			YGS_GUI_Personal:Show()
		end
	else
		YssGuildShop:Print("Please initialize YssGuildShop by visiting the bank")
	end
end

function YssGuildShop:OnUpdateFuBarTooltip()
    GameTooltip:AddLine("YssGuildShop")
    GameTooltip:AddDoubleLine("Hint:", "Left click to open UI", 0, 1, 0)
    GameTooltip:AddDoubleLine(" ", "Right click to open config/options", 0, 1, 0)
    -- as a rule, if you have an OnFuBarClick or OnFuBarDoubleClick
    -- or OnFuBarMouseUp or OnFuBarMouseDown, you should set a hint.
end


function YssGuildShop:OnInitialize()
	-- Called when the addon is loaded
end

function YssGuildShop:OnEnable()
	local ver_check = 0
	if YssGuildShop.db.account.YGSDB and YssGuildShop.db.account.YGSDB ~= {} then -- remove if public release (remove everything enclosed in the if statment)
		for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
			if ver_check == 0 then
				if tonumber(YssGuildShop.db.account.YGSDB[k]["YGS_ID"][3]) < YGS_low_comp_ver then
					ver_check = 1
					self:Print("YGS inventory database has been cleared due to major version revision.")
					self:Print("Thank you for upgrading to version: "..GetAddOnMetadata("YssGuildShop", "Version"))
					YssGuildShop:Nuke()
				end
			end
		end
	end
	-- Called when the addon is enabled
	YGS_sending = YGS_timestamp()
	YGS_mailbox_open = 0
	YGS_temp_perm = {}
	if YssGuildShop.db.char.YGS_value == nil then
		YssGuildShop.db.char.YGS_value = {}
	end
	if YssGuildShop.db.char.YGS_share_filter == nil then
		YssGuildShop.db.char.YGS_share_filter = {}
	end
	if YssGuildShop.db.char.YGS_value == nil then
		YssGuildShop.db.char.YGS_value = {}
		YssGuildShop.db.char.YGS_value["YGS_AC"] = true
	end
	YGS_Personal = {UnitName("player"), GetRealmName()}
	YGS_Guild = ""
	YGS_Bank = ""
	YGS_Personal_col = ""
	--self:RegisterEvent("BAG_UPDATE")
	self:AddEventListener("BANKFRAME_OPENED")
	self:AddEventListener("BANKFRAME_CLOSED")
	self:AddEventListener("MAIL_SHOW")
	self:AddEventListener("MAIL_CLOSED")
	self:AddEventListener("GUILD_ROSTER_UPDATE")
	self:AddEventListener("YGS_RequestDB")
	--self:RegisterEvent("CHAT_MSG_ADDON") --debug extreamly spammy to turn this on
	self:AddHook("OpenBackpack", "Hook_OpenBackpack")
	self:AddHook("ToggleBackpack", "Hook_ToggleBackpack")
	self:AddHook("OpenAllBags", "Hook_OpenAllBags")
	self:AddHook("OpenBag", "Hook_OpenBag")
	self:AddHook("ToggleBag", "Hook_ToggleBag")
	self:SetCommPrefix("YGS")
	self:AddCommListener("YGS", "GUILD", "ReceiveMessageGuild")
	self:AddCommListener("YGS", "WHISPER", "ReceiveMessageWhisper")
	if YssGuildShop.db.char.YGS_settings == nil then
		YssGuildShop.db.char.YGS_settings = {}
		YssGuildShop.db.char.YGS_settings[1] = true -- true for record data false for no recording
		YssGuildShop.db.char.YGS_settings[2] = true -- true for sharding data false for no sharing -- reset to false once testing is done
		YssGuildShop.db.char.YGS_settings[3] = true -- true if fubartext is set to show
		YssGuildShop.db.char.YGS_settings[4] = false -- reserved for future use
		YssGuildShop.db.char.YGS_settings[5] = false -- reserved for future use
		YssGuildShop.db.char.YGS_settings[6] = false -- reserved for future use
		YssGuildShop.db.char.YGS_settings[7] = false -- reserved for future use
		YssGuildShop.db.char.YGS_settings[8] = false -- reserved for future use
		YssGuildShop.db.char.YGS_settings[9] = false -- reserved for future use
	end
	GuildRoster()
end

function YssGuildShop:OnDisable()
	-- Called when the addon is disabled
end

function YGS_timestamp()
	local localOffset
	local localHour = tonumber(date("%H"))
	local localMinute = tonumber(date("%M"))
	local utcHour = tonumber(date("!%H"))
	local utcMinute = tonumber(date("!%M"))
	local loc = localHour + localMinute / 60
	local utc = utcHour + utcMinute / 60
	localOffset = floor((loc - utc) * 2 + 0.5) / 2
	if localOffset >= 12 then
		localOffset = localOffset - 24
	end
	local serverOffset
	local serverHour, serverMinute = GetGameTime()
	ser = serverHour + serverMinute / 60
	utc = utcHour + utcMinute / 60
	serverOffset = floor((ser - utc) * 2 + 0.5) / 2
	if serverOffset >= 12 then
		serverOffset = serverOffset - 24
	elseif serverOffset < -12 then
		serverOffset = serverOffset + 24
	end
	local Lyday = tonumber(date("%j"))
	if serverOffset-localOffset+serverHour > 24 then
		Lyday = Lyday - 1
	elseif serverOffset-localOffset+serverHour < 0 then
		Lyday = Lyday + 1
	end
	return (date("%Y")*1000000000)+(Lyday*1000000)+(serverHour*10000)+(serverMinute*100)+date("%S")
end

function YssGuildShop:Hook_OpenAllBags()
	self.hooks["OpenAllBags"]()
	--self:Print("OpenAllBags")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_ToggleBackpack()
	self.hooks["ToggleBackpack"]()
	--self:Print("ToggleBackpack")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_OpenBackpack()
	self.hooks["OpenBackpack"]()
	--self:Print("OpenBackpack")
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_OpenBag(bagID)
	self.hooks["OpenBag"](bagID)
	--self:Print("OpenBag " .. bagID)
	self:BAG_UPDATE()
end

function YssGuildShop:Hook_ToggleBag(bagID)
	self.hooks["ToggleBag"](bagID)
	--self:Print("ToggleBag " .. bagID)
	self:BAG_UPDATE()
end

function YssGuildShop:BAG_UPDATE()
	if YGS_mailbox_open == 0 and not InCombatLockdown() then
		local uniquecheck = 0
		if YssGuildShop.db.char.YGS_settings[1] == true then
			if UnitAffectingCombat("player") ~= 1 then
				--self:Print("Bag's Changed") --debugline
				YGS_BAG_PARSE()
			end
		else
			if YssGuildShop.db.account.YGSDB then
				for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
					if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == UnitName("player") then
						YssGuildShop.db.account.YGSDB[k] = {}
						YssGuildShop.db.account.YGSDB[k]["YGS_ID"] = self:YGS_ID()
						uniquecheck = 1
					end
					if uniquecheck == 0 then
						local ygs_db_leng = table.maxn(YssGuildShop.db.account.YGSDB)+1
						YssGuildShop.db.account.YGSDB[ygs_db_leng] = {}
						YssGuildShop.db.account.YGSDB[ygs_db_leng]["YGS_ID"] = self:YGS_ID()
					end
				end
			else
				YssGuildShop.db.account.YGSDB = {}
				YssGuildShop.db.account.YGSDB[1] = {}
				YssGuildShop.db.account.YGSDB[1]["YGS_ID"] = self:YGS_ID()
			end
			uniquecheck = 0
		end
	end
end

function YssGuildShop:BANKFRAME_OPENED()
	--self:Print("Bank Open")
	if YssGuildShop.db.char.YGS_settings[1] == true then
		YGS_BANK_PARSE()
		YGS_BAG_PARSE()
	end
end

function YssGuildShop:BANKFRAME_CLOSED()
	if YssGuildShop.db.char.YGS_settings[1] == true then
		--self:Print("Bank Close")
		YGS_BANK_PARSE()
		YGS_BAG_PARSE()
	end
end

function YssGuildShop:MAIL_SHOW()
	YGS_mailbox_open = 1
end

function YssGuildShop:MAIL_CLOSED()
	YGS_mailbox_open = 0
	self:BAG_UPDATE()
end

function YssGuildShop:GUILD_ROSTER_UPDATE()
	--self:Print("Guild Roster Update")
	if IsInGuild() then 
		if YssGuildShop.db.char.YGS_permission == nil or YssGuildShop.db.char.YGS_permission == {} then
			YssGuildShop.db.char.YGS_permission = {}
			YssGuildShop.db.char.YGS_permission[1] = {false,true,true} --{bank,admin,main}
			YssGuildShop.db.char.YGS_permission[2] = {false,true,true}
			for k=3,GuildControlGetNumRanks() do
				YssGuildShop.db.char.YGS_permission[k] = {false,false,false}
			end
		end
		if YssGuildShop.db.char.YGS_permission and YssGuildShop.db.char.YGS_permission ~= {} then
			if table.maxn(YssGuildShop.db.char.YGS_permission) > GuildControlGetNumRanks() then
				for k=1,table.maxn(YssGuildShop.db.char.YGS_permission)-GuildControlGetNumRanks() do
					table.remove(YssGuildShop.db.char.YGS_permission ,table.maxn(YssGuildShop.db.char.YGS_permission))
				end
			end
			if table.maxn(YssGuildShop.db.char.YGS_permission) < GuildControlGetNumRanks() then
				for k=1,GuildControlGetNumRanks()-table.maxn(YssGuildShop.db.char.YGS_permission) do
					table.insert(YssGuildShop.db.char.YGS_permission, {false,false,false})
				end
			end
		end
		YssGuildShop:Send_VR()
	end
end

function YssGuildShop:CHAT_MSG_ADDON(prefix, message, distribution, sender)
	if sender == UnitName("player") and prefix ~= "GC3" then
		self:Print("P: "..prefix)
		self:Print("M: "..message)
		self:Print("D: "..distribution)
		self:Print("S: "..sender)
		self:Print("sending msg with length of " .. string.len(message))
	end
end

-- DB testing functions
function YssGuildShop:YGS_Data_Dump()
	if YssGuildShop.db.account.YGSDB and YssGuildShop.db.account.YGSDB ~= {} then
		for k=1,table.maxn(YssGuildShop.db.account.YGSDB) do
			if YssGuildShop.db.account.YGSDB[k]["YGS_ID"][1] == UnitName("player") then
				for i=1,table.maxn(YssGuildShop.db.account.YGSDB[k]) do
					self:Print(YssGuildShop.db.account.YGSDB[k][i][1].." "..YssGuildShop.db.account.YGSDB[k][i][2])
				end
			end
		end
	end
end

function YssGuildShop:Nuke()
	YssGuildShop.db.account.YGSDB = nil
	YssGuildShop.db.char.YGSBANK = nil
	YssGuildShop.db.char.YGSBAG = nil
	YssGuildShop.db.char.YGS_share = nil
	YssGuildShop.db.char.YGS_settings[0] = nil
	self:Print("All inventory data has been deleted")
end

function YssGuildShop:YGS_ID()
	local id = {UnitName("player"),YGS_timestamp(),GetAddOnMetadata("YssGuildShop", "Version"), GetRealmName()}
	return id
end

